local AceGUI = LibStub("AceGUI-3.0")
do
	local Type = "Player_EditBox_SPTimer"
	local Version = 1
	local playerSpells = {}
	local frame
	
	local function spellFilter(self, spellID)
		return playerSpells[spellID]
	end
	
	local function loadPlayerSpells(self)
		table.wipe(playerSpells)

		for tab=2, GetNumSpellTabs() do
			local offset, numSpells  = select(3, GetSpellTabInfo(tab))
			
			
			for i=1, numSpells  do
			
				if GetSpellBookItemInfo(i + offset, tab) then
					self.tooltip:SetSpellBookItem(i + offset, tab)
					
					
					local spellName, _, spellID = self.tooltip:GetSpell()
					
					if( spellName ) then
						playerSpells[spellID] = true
					end
				end
			end
		end
	end
	
	-- I know theres a better way of doing this than this, but not sure for the time being, works fine though!
	local function Constructor()
		local self = AceGUI:Create("Predictor_Base_SPTimer")
		self.spellFilter = spellFilter

		if( not frame ) then
			frame = CreateFrame("Frame")
			frame:RegisterEvent("SPELLS_CHANGED")
			frame:SetScript("OnEvent", loadPlayerSpells)
			frame.tooltip = self.tooltip
			
			loadPlayerSpells(frame)
		end

		return self
	end
	
	AceGUI:RegisterWidgetType(Type, Constructor, Version)
end
