﻿SPTimers = LibStub("AceAddon-3.0"):NewAddon("SPTimers","AceEvent-3.0")
SPTimers.SharedMedia = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")
local ACD = LibStub("AceConfigDialog-3.0")

local message

-- NEW GLOBALS ----

local UNITAURA 				= "UNITAURA"
local CLEU 					= "CLEU"
local PLAYER_AURA 			= "PLAYER_AURA"
local OTHERS_AURA 			= "OTHERS_AURA"
local CUSTOM_AURA 			= "CUSTOM_AURA"
local CHANNEL_SPELL 		= "CHANNEL_SPELL"
local TOTEM_SPELL 			= "TOTEM_SPELL"
local SPELL_CAST 			= "SPELL_CAST"
local SPELL_SUMMON 			= "SPELL_SUMMON"
local SPELL_ENERGIZE 		= "SPELL_ENERGIZE"
local NO_GUID 				= "NO_GUID"
local NO_FADE 				= "NO_FADE"
local DO_FADE 				= "DO_FADE"
local DO_FADE_RED 			= "DO_FADE_RED"
local FADED 				= "FADED"
local DO_FADE_UNLIMIT 		= "DO_FADE_UNLIMIT"
local COOLDOWN_SPELL 		= "COOLDOWN_SPELL"

SPTimers.NO_FADE 			= NO_FADE
SPTimers.DO_FADE 			= DO_FADE
SPTimers.DO_FADE_RED 		= DO_FADE_RED
SPTimers.FADED 				= FADED
SPTimers.DO_FADE_UNLIMIT 	= DO_FADE_UNLIMIT
SPTimers.UNITAURA 			= UNITAURA
SPTimers.CLEU 				= CLEU
SPTimers.PLAYER_AURA 		= PLAYER_AURA
SPTimers.OTHERS_AURA 		= OTHERS_AURA
SPTimers.CUSTOM_AURA 		= CUSTOM_AURA
SPTimers.CHANNEL_SPELL 		= CHANNEL_SPELL
SPTimers.TOTEM_SPELL 		= TOTEM_SPELL
SPTimers.SPELL_CAST 		= SPELL_CAST
SPTimers.SPELL_SUMMON 		= SPELL_SUMMON
SPTimers.SPELL_ENERGIZE 	= SPELL_ENERGIZE
SPTimers.COOLDOWN_SPELL 	= COOLDOWN_SPELL
SPTimers.NO_GUID			= NO_GUID

------------------
----- minimap button config ---------------------------
local SPTimersLDB = LibStub("LibDataBroker-1.1"):NewDataObject("SPTimers Minimap", {
	type = "data source",
	text = "SPTimers",
	icon = "Interface\\Icons\\spell_shadow_shadowwordpain",
	OnClick = function()
		if not InCombatLockdown() then
			if ACD.OpenFrames["SPTimers"] then
				ACD:Close("SPTimers")
				SPTimers.delayOpeningOptions = false
			else
				ACD:Open("SPTimers")
			end
		else
			SPTimers.delayOpeningOptions = true		
			message(L["You can't do that while in combat"])	
		end
	end,
})
local minimap_icon = LibStub("LibDBIcon-1.0")
--------------------------------------------------------

local parent = CreateFrame('Frame', 'SPTimersParent', UIParent);
parent:SetFrameLevel(UIParent:GetFrameLevel());
parent:SetPoint('TOPLEFT', UIParent, 'TOPLEFT');
parent:SetPoint('BOTTOMRIGHT', UIParent, 'BOTTOMRIGHT');
parent:SetSize(UIParent:GetSize());

SPTimers.Parent = parent

-- locals -----------------------

local myGUID, myCLASS
local options
local UnitGUID = UnitGUID
local math_floor = math.floor
local L = LibStub("AceLocale-3.0"):GetLocale("SPTimers")
local pairs = pairs
local ipairs = ipairs
local tinsert = table.insert

-- debug print ------------------
local old_print = print
local print = function(...)
	if SPTimers.dodebugging then	
		old_print(GetTime(), "SPTimers_CORE, ", ...)
	end
end

local old_assert = assert
local assert = function(...)
	if SPTimers.dodebugging then	
		old_assert(...)
	end
end

do
	local SendChatMessage = SendChatMessage
	local IsInRaid, IsInGroup = IsInRaid, IsInGroup
	local LE_PARTY_CATEGORY_INSTANCE = LE_PARTY_CATEGORY_INSTANCE
	local LE_PARTY_CATEGORY_HOME = LE_PARTY_CATEGORY_HOME
	
	function SPTimers.ChatMessage(msg, chat)
		
		if chat == "RAID_WARNING" then
			SendChatMessage(msg, "RAID_WARNING")
		elseif chat == "PARTY" then
			SendChatMessage(msg, "PARTY")
		elseif chat == "GUILD" then
			SendChatMessage(msg, "GUILD")
		else
			local chatType = "PRINT"
			if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) or IsInRaid(LE_PARTY_CATEGORY_INSTANCE) then
				chatType = "INSTANCE_CHAT"
			elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
				chatType = "RAID"
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				chatType = "PARTY"
			end
			
			if chatType == "PRINT" then
				SPTimers.message(msg)
			else
				SendChatMessage(msg, chatType)
			end
		end
	--	AddOn:print("Message", msg, chatType)
	end
end


do
	local select = select
	local tostring = tostring
	local sub = string.sub	
	local icon = "\124TInterface\\Icons\\spell_shadow_shadowwordpain:10\124t"
	
	function SPTimers.message(...)
	--	old_print("SPTimers_Options:", ...)
		local msg = ""
		for i=1, select("#", ...) do
			
			msg = msg..tostring(select(i, ...))..","
		end	
		msg = sub(msg, 0, -2)
		
		DEFAULT_CHAT_FRAME:AddMessage(icon.."SPTimers:"..msg)	
	end

end

message = SPTimers.message

---------------------------------

local function Round(num) return math_floor(num+.5) end
local function SecondsRound(num)
	if num > 2 then return math_floor(num+.5)
	else return math_floor(num*10+.5)/10 end
end


SLASH_SPTIMERS1 = '/sptimers'
function SPTimersHandler(msg, editBox)
	if not InCombatLockdown() then
		if ACD.OpenFrames["SPTimers"] then
			ACD:Close("SPTimers")
			SPTimers.delayOpeningOptions = false
		else
			ACD:Open("SPTimers")
		end
	else
		SPTimers.delayOpeningOptions = true		
		message(L["You can't do that while in combat"])	
	end
end
SlashCmdList["SPTIMERS"] = SPTimersHandler


do
	SPTimers.targetEngaged = {}
	SPTimers.onUpdateHandler  = CreateFrame("Frame")
	
	local onUpdateHandler = SPTimers.onUpdateHandler	
	onUpdateHandler.elapsed = 0
	onUpdateHandler.active = false

	local function onUpdateCombat(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		if self.elapsed < options.throttleOutCombat then return end		
		self.elapsed = 0

		if not IsEncounterInProgress() and not InCombatLockdown() then
			self.active = false
			wipe(SPTimers.targetEngaged)
			wipe(SPTimers.pandemia_cache)
			SPTimers:OnCombatEndReset()
			self:SetScript("OnUpdate", nil)
		else
			local current = GetTime()
			for guid, last in pairs(SPTimers.targetEngaged) do				
				if last <= current then

					SPTimers.targetEngaged[guid] = nil

					SPTimers.Timer_Remove_DEAD(guid, true)
					
					print("Clear DestGUID by noActive", guid)
				end	
			end
		end	
	end
	
	--onUpdateHandler:SetScript("OnUpdate", onUpdateCombat)
	
	function SPTimers:MouseOverOnUpdate()
		if onUpdateHandler.active == false and not SPTimers.testbar_shown then		
			onUpdateHandler:SetScript("OnUpdate", onUpdateCombat)
			onUpdateHandler.elapsed = -5
			onUpdateHandler.active = true
		end
	end
	
	function SPTimers:PLAYER_REGEN_ENABLED() 
		onUpdateHandler.elapsed = 0
		
		if self.delayOpeningOptions then
			ACD:Open("SPTimers")
			SPTimers.delayOpeningOptions = false
		end
	end
	
	
	function SPTimers:PLAYER_REGEN_DISABLED()	
		if ACD.OpenFrames["SPTimers"] then 
			self.delayOpeningOptions = true
			ACD:Close("SPTimers")
		end
		
		if options.bar_module_enabled then
			onUpdateHandler:SetScript("OnUpdate", onUpdateCombat)
			if SPTimers.testbar_shown then self:TestBars(true) end
		end
		onUpdateHandler.active = true
	end
end

do
	local several_auras = {}
	
	local function PlayerAurasFilter(spellID, filter_type, sUnit)
		local skip = false
	
		skip = SPTimers:GetWhiteListFilter(spellID, filter_type, skip)
		skip = SPTimers:GetBlackListFilter(spellID, filter_type, skip)
		skip = SPTimers:GetProcsFilter(spellID, filter_type, skip)
		skip = SPTimers:GetOthersFilter(spellID, filter_type, skip)
		
		if skip then skip = SPTimers:CheckUnitSource(sUnit, SPTimers:GetAffiliation(spellID)) end
		
		return skip
	end
	
	local function OthersAurasFulter(spellID, filter_type, unit, sUnit)
		local skip = false
	
	--	skip = SPTimers:GetOthersFilter(spellID, filter_type, skip)
		skip = SPTimers:GetWhiteListFilter(spellID, filter_type, skip)
		skip = SPTimers:GetBlackListFilter(spellID, filter_type, skip)
		if SPTimers:IsChanneling(spellID) then skip = false end						
		if skip then skip = SPTimers:CheckUnitSource(sUnit, SPTimers:GetAffiliation(spellID)) end
		if skip then skip = SPTimers:CheckUnitSource(unit, SPTimers:GetTargetAffiliation(spellID)) end

		return skip
	end
	
	local _, spellName, icon, amount, debuffType, duration, endTime, sUnit, spellID, sourceGUID, skip, destGUID, filter, auraType, filter_type, index, sourceName
	
	local function PlayerAuras(unit)

		destGUID = UnitGUID(unit)
		filter, auraType, filter_type, index = "HELPFUL", "BUFF", 2, 1
		
		wipe(several_auras)
		
		while ( true ) do
			spellName, _, icon, amount, debuffType, duration, endTime, sUnit, _, _, spellID = UnitAura(unit, index, filter)		
			if not spellName then break end
			
			if SPTimers:GetInternalCD(spellName, spellID) then
				local icd = SPTimers:GetICD(spellName, spellID)
				if icd > 0 and ( endTime ~= 0 and duration ~= 0 ) then
					icd = icd + endTime - duration
					SPTimers.NewCooldown(spellName, icon, icd, "INTERNAL_CD")
				end
			end
			
			if endTime ~= 0 and SPTimers:GetAuraCD(spellName, spellID, filter) then
				SPTimers.NewCooldown(spellName.." buff", icon, endTime, "AURA_CD_BUFF")
			end
			
			index = index + 1
			
			if PlayerAurasFilter(spellID, filter_type, sUnit) then
				sourceGUID = UnitGUID(sUnit or "")
		
				if SPTimers:IsSeveralAuras(spellID) then
					several_auras[spellID] = ( several_auras[spellID] or 0 ) + 1
				end
					
				sourceName = UnitName(sUnit or "") or SPTimers.myNAME
		
				SPTimers.Timer(duration, endTime, destGUID, sourceGUID, spellID, several_auras[spellID] or 1, auraType, PLAYER_AURA, GetRaidTargetIndex(unit), spellName, icon, amount, SPTimers.myNAME, sourceName)
			end
		end

		filter, auraType, filter_type, index = "HARMFUL", "DEBUFF", 3, 1

		while ( true ) do
			spellName, _, icon, amount, debuffType, duration, endTime, sUnit, _, _, spellID = UnitAura(unit, index, filter)		
			if not spellName then break end
			
			if endTime ~= 0 and SPTimers:GetAuraCD(spellName, spellID, filter) then
				SPTimers.NewCooldown(spellName.." debuff", icon, endTime,"AURA_CD_DEBUFF")
			end
			
			index = index + 1
			
			if PlayerAurasFilter(spellID, filter_type, sUnit) then
				sourceGUID = UnitGUID(sUnit or "")
				sourceName = UnitName(sUnit or "") or SPTimers.myNAME
				
				SPTimers.Timer(duration, endTime, destGUID, sourceGUID, spellID,  1, auraType, PLAYER_AURA, GetRaidTargetIndex(unit), spellName, icon, amount, SPTimers.myNAME, sourceName)
			end
		end
		
		SPTimers.RemoveGUID_UA(destGUID, "BUFF", PLAYER_AURA, GetTime())
		SPTimers.RemoveGUID_UA(destGUID, "DEBUFF", PLAYER_AURA, GetTime())
	end

	local units = { 
		target = 1,
		focus = 1,
		boss1 = 1,
		boss2 = 1,
		boss3 = 1,
		boss4 = 1,
		boss5 = 1,
		arena1 = 1,
		arena2 = 1,
		arena3 = 1,
		arena4 = 1,
		arena5 = 1,
		mouseover = 1,
	}
	
	local function OthersAuras(unit)

	--	if not UnitCanAttack("player", unit) then return end

		if unit ~= "target" then 
			if UnitExists("target") and UnitIsUnit(unit, "target") then return end	
			if unit ~= "focus" and UnitExists("focus") and UnitIsUnit(unit, "focus") then return end
		end

		destGUID = UnitGUID(unit)
		filter, auraType, filter_type, index = "HARMFUL", "DEBUFF", 3, 1

		while ( true ) do
			spellName, _, icon, amount, debuffType, duration, endTime, sUnit, _, _, spellID = UnitAura(unit, index, filter)		
			if not spellName then break end
	
			index = index + 1
			
			if OthersAurasFulter(spellID, filter_type, unit, sUnit) then
				sourceGUID = UnitGUID(sUnit or "")
				
				
				SPTimers.Timer(duration, endTime, destGUID, sourceGUID, spellID, 1, auraType, OTHERS_AURA, GetRaidTargetIndex(unit), spellName, icon, amount,UnitName(unit), UnitName(sUnit or "") or UnitName(unit))
			end
		end

		filter, auraType, filter_type, index = "HELPFUL", "BUFF", 2, 1

		while ( true ) do
			spellName, _, icon, amount, debuffType, duration, endTime, sUnit, _, _, spellID = UnitAura(unit, index, filter)		
			if not spellName then break end
	
			index = index + 1
			
			if OthersAurasFulter(spellID, filter_type, unit, sUnit) then
				sourceGUID = UnitGUID(sUnit or "")
				
				
				SPTimers.Timer(duration, endTime, destGUID, sourceGUID, spellID, 1, auraType, OTHERS_AURA, GetRaidTargetIndex(unit), spellName, icon, amount,UnitName(unit), UnitName(sUnit or "") or UnitName(unit))
			end
		end
		
		SPTimers.RemoveGUID_UA(destGUID, "DEBUFF", OTHERS_AURA, GetTime())
		SPTimers.RemoveGUID_UA(destGUID, "BUFF", OTHERS_AURA, GetTime())
	end
	
	local __frf = CreateFrame("Frame")
	__frf:Show()
	__frf.elapsed = 0
	__frf:SetScript("OnUpdate", function(self, elapsed)
		
		self.elapsed = self.elapsed + elapsed
		if self.elapsed < 0.25 then return end
		self.elapsed = 0
		
	--	SPTimers:UNIT_AURA(nil, "player")
		
		PlayerAuras("player")
	end)
	
	function SPTimers:UNIT_AURA(event, unit)
		if unit and not UnitExists(unit) then return end
	
		if unit == "player" then 
			PlayerAuras(unit)
		elseif units[unit] then 
			OthersAuras(unit) 
		end
	end
	
	
	function SPTimers:PLAYER_TARGET_CHANGED(event)
		if UnitExists("target") then
			self.CurrentTarget = UnitGUID("target")		
		--	self:UNIT_AURA(nil, "target")
			OthersAuras("target") 
		else
			self.CurrentTarget = nil
		end
		
		self.SortBars()
	end

	function SPTimers:UPDATE_MOUSEOVER_UNIT(event)
		if UnitExists("mouseover") then
			OthersAuras("mouseover")
		end
	end
	
	function SPTimers:PLAYER_FOCUS_CHANGED()
		if UnitExists("focus") then
			self.FocusTarget = UnitGUID("focus")
		--	self:UNIT_AURA(event, "focus")
			OthersAuras("focus") 
		else
			self.FocusTarget = nil
			self.SortBars()
		end
	
	end
end


do
	local string_match = string.match
	function SPTimers.Erase(name)
		if not name then return name end
		local rname = string_match(name, "(.+)-") or name
		return rname
	end
end

do
	
	local flagtort = {
		[COMBATLOG_OBJECT_NONE] = 0,
		[COMBATLOG_OBJECT_RAIDTARGET8] = 8,
		[COMBATLOG_OBJECT_RAIDTARGET7] = 7,
		[COMBATLOG_OBJECT_RAIDTARGET6] = 6,
		[COMBATLOG_OBJECT_RAIDTARGET5] = 5,
		[COMBATLOG_OBJECT_RAIDTARGET4] = 4,
		[COMBATLOG_OBJECT_RAIDTARGET3] = 3,
		[COMBATLOG_OBJECT_RAIDTARGET2] = 2,
		[COMBATLOG_OBJECT_RAIDTARGET1] = 1,
	}
		

	SPTimers.dots = {}
	local dots = SPTimers.dots
	
	local truedEvents = {
		SPELL_CAST_SUCCESS = 1,
		SPELL_AURA_REFRESH = 1,
		SPELL_AURA_APPLIED_DOSE = 1,
		SPELL_AURA_APPLIED = 1,
		SPELL_AURA_REMOVED = 1,
		SPELL_AURA_REMOVED_DOSE = 1,
		SPELL_SUMMON = 1,
		SPELL_ENERGIZE = 1,
	}

	function SPTimers:GetTickInfo(spellID, destGUID)

		local tick, hasted, pandemia = self:GetCLEUSpellInfo(spellID)

		if not tick then return false end
		
		local haste = UnitSpellHaste("player")
		
		local tick_every = 0
		
		if hasted then
			tick_every	= tick/(1+(haste/100))
		else
			tick_every	= tick
		end

		dots[spellID..destGUID] = tick_every
	end
	
	local new_dot = {}
	function SPTimers:GetDotInfo(spellID, destGUID)
		destGUID = destGUID or SPTimers.myGUID
		
		local tick, hasted, pandemia = self:GetCLEUSpellInfo(spellID)
		local default, extended = self:GetDefaultDuraton(spellID)
		
		if not tick then return false end
		
		local haste = UnitSpellHaste("player")
		
		local tick_every = 0
		
		if hasted then
			tick_every	= tick/(1+(haste/100))
		else
			tick_every	= tick
		end
		
		if not new_dot[spellID..destGUID] then
			new_dot[spellID..destGUID] = { tick_every, math_floor(default/tick_every), math_floor(extended/tick_every) }
		else
			new_dot[spellID..destGUID][1] = tick_every
			new_dot[spellID..destGUID][2] = math_floor(default/tick_every)
			new_dot[spellID..destGUID][3] = math_floor(extended/tick_every)
		end
		
		return new_dot[spellID..destGUID][1], new_dot[spellID..destGUID][2], new_dot[spellID..destGUID][3]
	end
	
	function SPTimers:GetDotInfoDone(spellID, destGUID)
		
		if new_dot[spellID..destGUID] then return new_dot[spellID..destGUID][1], new_dot[spellID..destGUID][2], new_dot[spellID..destGUID][3] end

		return SPTimers:GetDotInfo(spellID, destGUID)
	end
	
	local TYPE_PLAYER = COMBATLOG_OBJECT_TYPE_PLAYER
	local TYPE_NPC	  = COMBATLOG_OBJECT_TYPE_NPC
	
	local function IsPlayer(flag)
		if flag and ( bit.band(flag, TYPE_PLAYER) > 0 ) then return true end
		return false
	end
	
	local function IsNPC(flag)
		if flag and ( bit.band(flag, TYPE_NPC) > 0 ) then return true end
		return false
	end
	
	local anchor, endTime, showticks, sourceFunc
	local name, stacks, duration, unitCaster, debuffType


	function SPTimers:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventType, hideCaster,
					srcGUID, srcName, srcFlags, srcFlags2,
					dstGUID, dstName, dstFlags, dstFlags2,
					spellID, spellName, spellSchool, auraType, amount, extraSchool, extraType, ...)
			
			anchor, endTime, showticks, sourceFunc  = 1, nil, false, "CLEU"

			if eventType == "UNIT_DIED" or eventType == "UNIT_DESTROYED" or eventType == "SPELL_INSTAKILL" or eventType == "PARTY_KILL" then
				self.targetEngaged[dstGUID] = nil
				SPTimers.Timer_Remove_DEAD(dstGUID)	
				return
			end
			
			

			if not truedEvents[eventType] then return end		
			if srcGUID ~= self.myGUID and srcGUID ~= self.petGUID then return end
			
		--	print("T", eventType, spellName,srcName, dstName)
			
			dstName = dstName or spellName or srcName or ""
			
			if eventType == "SPELL_CAST_SUCCESS" then 
				auraType = SPELL_CAST
			elseif eventType == "SPELL_SUMMON" then
				auraType = SPELL_SUMMON
			elseif eventType == "SPELL_ENERGIZE" then
				auraType = SPELL_ENERGIZE
			end

			if not self:GetCLEUFilter(spellID, auraType) then return end
			if self:IsChanneling(spellID) then return end	
			if not self:CLEU_AffilationCheck(srcFlags, spellID) then return end
			if not self:CLEU_AffilationCheckTarget(dstFlags, spellID) then return end
			
			if not self:UnitFilter_GUID(dstGUID) then return end

			local tick, haste, pandemia = self:GetCLEUSpellInfo(spellID)
			if tick then showticks = true end

			local isplayer = IsPlayer(dstFlags)
			local icon = GetSpellTexture(spellID)
			
			local destName = isplayer and SPTimers.Erase(dstName) or dstName
			
			if eventType == "SPELL_AURA_REFRESH" then
				local name, amount, spell_id, duration, endTime_1, unitCaster, debuffType = SPTimers:GuidAuraInfo(dstGUID, spellID, auraType)
				return SPTimers.Timer(self:GetDuration(spellID, dstGUID, 2, isplayer), endTime, dstGUID, srcGUID, spellID, 1, auraType, CLEU, flagtort[dstFlags2], spellName, icon, amount or 0, destName, srcName)
			elseif eventType == "SPELL_AURA_APPLIED_DOSE" then
				return SPTimers.Timer_DOSE(dstGUID, srcGUID, spellID, 1, auraType, CLEU, flagtort[dstFlags2], amount)
			elseif eventType == "SPELL_AURA_APPLIED" then
				
				local name, amount, spell_id, duration, endTime_1, unitCaster, debuffType = SPTimers:GuidAuraInfo(dstGUID, spellID, auraType)
				
				if showticks then 
					self:GetTickInfo(spellID, dstGUID) 
					if pandemia then self:RegisterDotApply(dstGUID, spellID) end
				end
				return SPTimers.Timer(self:GetDuration(spellID, dstGUID, 1, isplayer), endTime, dstGUID, srcGUID, spellID, 1, auraType, CLEU, flagtort[dstFlags2], spellName, icon, amount or 0, destName, srcName)
			elseif eventType == "SPELL_AURA_REMOVED" then
				self:RemovePandemia(spellID, dstGUID)
				
				if showticks then 
					self:RemoveDotFromDB(dstGUID, spellID)
				end
				
				return SPTimers.Timer_Remove(dstGUID, srcGUID, spellID, 1, auraType)				
			elseif event == "SPELL_AURA_BROKEN" or event == "SPELL_AURA_BROKEN_SPELL" then
			
		--		print(eventType, srcName, spellID, spellName, dstName, dstGUID, srcGUID,auraType)
			elseif eventType == "SPELL_AURA_REMOVED_DOSE" then
				return SPTimers.Timer_DOSE(dstGUID, srcGUID, spellID, 1, auraType, CLEU, flagtort[dstFlags2], amount)
			elseif eventType == "SPELL_SUMMON" then
				return SPTimers.Timer(self:GetDuration(spellID, dstGUID, 1, isplayer), endTime, dstGUID, srcGUID, spellID, 1, auraType, CUSTOM_AURA, flagtort[dstFlags2], spellName, icon, amount or 0, destName, srcName)
			elseif eventType == "SPELL_CAST_SUCCESS" then
			
				if showticks and not pandemia then 									
					if not dstGUID then dstGUID = srcGUID end
					self:GetTickInfo(spellID, dstGUID) 
				end

				return SPTimers.Timer(self:GetDuration(spellID, dstGUID, 1, isplayer), endTime, dstGUID, srcGUID, spellID, 1, auraType, CUSTOM_AURA, flagtort[dstFlags2], spellName, icon, amount or 0, destName, srcName)
			elseif eventType == "SPELL_ENERGIZE" then

				return SPTimers.Timer(self:GetDuration(spellID, nil, nil, isplayer), endTime, dstGUID, srcGUID, spellID, 1, auraType, CUSTOM_AURA, flagtort[dstFlags2], spellName, icon, amount or 0, destName, srcName)
			end
	end
end

do

	local spellname_list = {}
	
	local exists_cd = {}

	local GetSpellBaseCooldown = GetSpellBaseCooldown
	
	local function GetSpellCooldownCharges(spellID)
		local startTime, duration, enabled = GetSpellCooldown(spellID)
		local charges, maxCharges, chargeStart, chargeDuration = GetSpellCharges(spellID)
		if charges and charges ~= maxCharges then
			startTime = chargeStart
			duration = chargeDuration
		end
		return startTime, duration, enabled, charges, maxCharges
	end

	
	local cd_frame = CreateFrame("Frame")
	cd_frame:SetScript("OnUpdate", function(self, elapsed)
		self.elapsed = ( self.elapsed or 0 ) + elapsed
		
		if self.elapsed < 0.2 then return end
		self.elapsed = 0
		
		local curtime = GetTime()
		
		for k,v in pairs(spellname_list) do
			local startTime, duration, enabled, charges, maxCharges = GetSpellCooldownCharges(v)
			
			if enabled and duration > 1.5 then			
				exists_cd[v] = curtime
				SPTimers.Timer(duration, startTime+duration, COOLDOWN_SPELL, COOLDOWN_SPELL, v, 1, COOLDOWN_SPELL, COOLDOWN_SPELL, 0, k, nil, 0, k, k)
			end
		end
		
		for k,v in pairs(exists_cd) do
			
			if v < curtime then			
				SPTimers.Timer_Remove(COOLDOWN_SPELL, COOLDOWN_SPELL, k, 1, COOLDOWN_SPELL)
				v = nil
			end
		end
	end)
	
	SPTimers.UpdateBarsSpellList = function(self)
	
		for spellid, data in pairs(options.bars_cooldowns[self.myCLASS] or {}) do
	
			if not data.hide and not data.deleted then
				spellname_list[GetSpellInfo(spellid)] = spellid
			end
		end
		
		
	end
	
	
	SPTimers.UpdateBars_CooldownPart = function(self)
		
		if options.bar_module_enabled then
			cd_frame:Show()
		else
			cd_frame:Hide()		
		end
		
		self:UpdateBarsSpellList()
	end
end

do

	local channel_spell = {}

	local function UpdateChannelInfo(haste, anchor, showticks, spellID)
		if haste then		
			SPTimers:GetTickInfo(spellID, CHANNEL_SPELL)
		end
		
		local spell, _, displayName, icon, startTime, endTime, _, _, _ = UnitChannelInfo("player")
		
		if spell then
			local playerName = SPTimers.myNAME -- UnitName("player")
			local targetName = UnitName("target") or playerName

			return SPTimers.Timer((endTime-startTime)/1000, endTime/1000, CHANNEL_SPELL, SPTimers.myGUID, CHANNEL_SPELL, 1, CHANNEL_SPELL, CHANNEL_SPELL, nil, spell, icon, 0, targetName, playerName, spellID)
		end
	end
	
	function SPTimers:ScanForChannelingSpell()
		for k,v in pairs(self.db.profile.classSpells[self.myCLASS]) do
			local spell = GetSpellInfo(k)
			
			if spell then
				if v.channel then				
					channel_spell[spell] = k
				else				
					if channel_spell[spell] and not v.channel then
						channel_spell[spell] = nil			
					end
				end
			end
		end
	end
	
	function SPTimers:UNIT_SPELLCAST_CHANNEL_START(event,unit,spell,lineID,spellID)	
		if unit ~= "player" then return end

		local spellID = channel_spell[spell]		
		if not spellID then return end
		
	--	local anchor = self:GetAnchor(spellID)
		local showticks = self:GetCLEUSpellInfo(spellID)
		
	--	self.unitThrottle["target"] = 0
	--	self.unitThrottle["focus"] = 0
		
	--	self.GetUnitDebuffs("target", "UNIT_SPELLCAST_CHANNEL_START")
		
		self:UNIT_AURA(nil, "target")
		
		local skip = false 
		
		skip = SPTimers:GetWhiteListFilter(spellID, "BUFF", skip)
		skip = SPTimers:GetBlackListFilter(spellID, "BUFF", skip)
			
		if skip then
			UpdateChannelInfo(true, anchor, showticks, spellID)
		end
	end
	
	function SPTimers:UNIT_SPELLCAST_CHANNEL_STOP(event,unit, spell, rank, lineID, spellID)
		if unit ~= "player" then return end
		
	--	print(event, unit, spell, spellID)
		--local spellID = channel_spell[spell]		
		--if not spellID then return end		
		if not SPTimers:IsChanneling(spellID) then return end

	--	self:RemoveTimersGUID(CHANEL_SPELL, spellID, self.myGUID, CHANEL_SPELL, true)
		
		SPTimers.Timer_Remove(CHANNEL_SPELL, self.myGUID, CHANNEL_SPELL, 1, CHANNEL_SPELL)	
		
	end

	function SPTimers:UNIT_SPELLCAST_CHANNEL_UPDATE(event,unit, spell, rank, lineID, spellID)
		if unit ~= "player" then return end
	--	local spellID = channel_spell[spell]		
	--	if not spellID then return end
		if not SPTimers:IsChanneling(spellID) then return end
	--	local anchor = self:GetAnchor(spellID)
		local showticks = self:GetCLEUSpellInfo(spellID)
		
	--	print(event, unit, spell, spellID)
		local skip = false 
		
		skip = SPTimers:GetWhiteListFilter(spellID, "BUFF", skip)
		skip = SPTimers:GetBlackListFilter(spellID, "BUFF", skip)
			
		if skip then
			UpdateChannelInfo(false, anchor, showticks, spellID)
		end
	end
	
	
	
	function SPTimers:UNIT_SPELLCAST_SENT(event,unit,spell,rank,target,lineID)
		if unit ~= "player" then return end
		
		--print(event, target)
		--	self.unitThrottle["target"] = 0
		--	self.unitThrottle["focus"] = 0
			
	--	self.GetUnitDebuffs("target", "UNIT_SPELLCAST_SENT")
	
		self:UNIT_AURA(nil, "target")
	end
	
	function SPTimers:UNIT_SPELLCAST_START(event,unit,spell,rank,lineID,spellID) --"unitID", "spell", "rank", lineID, spellID
		if unit ~= "player" then return end
		--	self.unitThrottle["target"] = 0
		--	self.unitThrottle["focus"] = 0
		
		--print(event, target)
	--	self.GetUnitDebuffs("target", "UNIT_SPELLCAST_START")
	
		self:UNIT_AURA(nil, "target")
	end
	
	function SPTimers:UNIT_SPELLCAST_SUCCEEDED(event,unit,spell,rank,lineID,spellID)
		if unit ~= "player" then return end
		
		--print(event, target)
	--	self.GetUnitDebuffs("target", "UNIT_SPELLCAST_SENT")
	
		self:UNIT_AURA(nil, "target")
	end
	
	function SPTimers:UNIT_SPELLCAST_STOP(event,unit,spell,rank,lineID,spellID)
		if unit ~= "player" then return end
		
		--print(event, target)
	end
end


function SPTimers:PLAYER_LOGIN()
	self.myGUID = UnitGUID("player")
	local _,class = UnitClass("player")	
	self.myCLASS = class
	self.myNAME = UnitName("player")
end

function SPTimers:UNIT_PET(event, unit)
	if unit == "player" then
		if UnitExists("pet") then
			self.petGUID = UnitGUID("pet")
		else
			self.petGUID = nil
		end
	end
end

do
	
	local totemsName = {}
	local totemItems = {5176, 5175, 5177, 5178 }
	
	-- 5176 -- Fire , 5175 -- Earth, 5178 -- Air , 5177 -- Water
	
	local function GetTotemFilter(i)
		
		if not totemsName[i] then
			totemsName[i] = GetItemInfo(totemItems[i])
		--	print("GetTotemFilter", totemsName[i])

		end
		
		return totemsName[i]
	end
	
	local loop = CreateFrame("Frame")
	loop.elapsed = 0
	loop:Hide()
	loop:SetScript("OnUpdate", function(self, elapsed)
		self.elapsed = self.elapsed + elapsed

		local alldone = true
		
		for i=1, MAX_TOTEMS do
			if GetTotemFilter(i) == nil then		
				alldone = false
			end
		end
		
		if alldone then
		--	print("Complete cache item in "..format("%.1f", self.elapsed).."s.")
			
			for i=1, MAX_TOTEMS do
				SPTimers:PLAYER_TOTEM_UPDATE(nil, i)
			end
			
			self.elapsed = 0
			self:Hide()
		end
	end)
	
	
	function SPTimers:UpdateTotems()
		if ( self.myCLASS == "SHAMAN" or self.myCLASS == "DRUID" ) then
			if ( self:ShowTotems("totem1") or self:ShowTotems("totem2") or self:ShowTotems("totem3") or self:ShowTotems("totem4") ) then
				self:RegisterEvent("PLAYER_TOTEM_UPDATE")
				loop:Show()
			end
		else	
			self:UnregisterEvent("PLAYER_TOTEM_UPDATE")
			for i=1, MAX_TOTEMS do
				SPTimers:PLAYER_TOTEM_UPDATE(nil, i, true)
			end
		end
	end
	
	-- TOTEM_SPELL
	
	function SPTimers:PLAYER_TOTEM_UPDATE(event, totem, rem)
--		print("PLAYER_TOTEM_UPDATE", totem)
		local anchor = self:GetAnchor("totem"..totem)
		local haveTotem, totemName, startTime, duration, icon = GetTotemInfo(totem)
		if not rem and self:ShowTotems("totem"..totem) and haveTotem and ( GetTotemFilter(totem) ~= totemName )then
			SPTimers.Timer(duration, startTime+duration, self.myGUID, self.myGUID, "totem"..totem, 1, "BUFF", TOTEM_SPELL, nil, totemName, icon, 0,self.myNAME, self.myNAME)
		else
			SPTimers.Timer_Remove(self.myGUID, self.myGUID, "totem"..totem, 1, "BUFF")
		end
	end
end

do
	local delayupdate = CreateFrame("Frame", nil, UIParent)
	delayupdate.elapsed = 0
	delayupdate.updates = {}
	delayupdate:Show()
	delayupdate:SetScript("OnUpdate", function(self, elapsed)
		self.elapsed = self.elapsed + elapsed
		
		if self.elapsed < 1 then return end
		
		for _,func in pairs(self.updates) do
			func()
		end
		
		wipe(self.updates)
		self:Hide()
	end)

	function SPTimers:PlayerLoginDelay(func)
		if type(func) == "function" then	
			table.insert(delayupdate.updates, func)
		end
	end
end

function SPTimers:CoreBarsStatusUpdate()
	if options.bar_module_enabled then
		
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("PLAYER_FOCUS_CHANGED")
		self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
--		self:RegisterEvent("UNIT_INVENTORY_CHANGED")
		self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
		self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
		self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
		self:RegisterEvent("UNIT_SPELLCAST_SENT")
		self:RegisterEvent("UNIT_SPELLCAST_START")
		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:RegisterEvent("UNIT_SPELLCAST_STOP")
--		self:RegisterEvent("COMBAT_RATING_UPDATE")
		
--		self.checkUnitOnUpdate:SetScript("OnUpdate", self.checkUnitOnUpdateFunc)
	else
		self:UnregisterEvent("PLAYER_TARGET_CHANGED")
		self:UnregisterEvent("PLAYER_FOCUS_CHANGED")
		self:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
--		self:UnregisterEvent("UNIT_INVENTORY_CHANGED")
		self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_START")
		self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
		self:UnregisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
		self:UnregisterEvent("UNIT_SPELLCAST_SENT")
		self:UnregisterEvent("UNIT_SPELLCAST_START")		
		self:UnregisterEvent("PLAYER_TOTEM_UPDATE")
		self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:UnregisterEvent("UNIT_SPELLCAST_STOP")
--		self:UnregisterEvent("COMBAT_RATING_UPDATE")
		
--		self.checkUnitOnUpdate:SetScript("OnUpdate", nil)
	end
	
	self:UpdateBars_CooldownPart()
end

function SPTimers:UpdateMinimap() 
	if options.minimap.hide then
		minimap_icon:Show("SPTimers Minimap")
	else
		minimap_icon:Hide("SPTimers Minimap")
	end
end


local forced = true
function SPTimers:CheckDebugging()
	
	local _, battleTag = BNGetInfo()
	local myBTag = GetAddOnMetadata("SPTimers", "Author")
	
	if battleTag then
		if myBTag == battleTag and forced then 
			self.dodebugging = true
			message("DEBUGGING ON")
		end
		
	--	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self:UnregisterEvent("BN_CONNECTED")
		self:UnregisterEvent("BN_SELF_ONLINE")
		self:UnregisterEvent("BN_INFO_CHANGED")
	end
end

SLASH_SPTIMERSDEBUG1 = '/sptimersdebugging'
function SPTIMERSDEBUGHandler(msg, editBox)
	SPTimers.dodebugging = not SPTimers.dodebugging
	
	message( (SPTimers.dodebugging and "DEBUGGING ON" or "DEBUGGING OFF" ) )
end

SlashCmdList["SPTIMERSDEBUG"] = SPTIMERSDEBUGHandler

do
	local raid = {}
	
	SPTimers.RaidRoster = raid
	
	local IsInRaid, IsInGroup = IsInRaid, IsInGroup
	local inraid = false
	local format = format
	local wipe = wipe
	local UnitExists = UnitExists
	local GetNumGroupMembers, GetNumSubgroupMembers = GetNumGroupMembers, GetNumSubgroupMembers
	local UnitAura, GetSpellInfo = UnitAura, GetSpellInfo
	
	local function LeaveFromRaidOrGroup()
		if not IsInRaid() then
			if inraid then inraid = false; wipe(raid) end
		elseif IsInRaid() then
			if not inraid then inraid = true end
		end
	end
	
	local function CheckUnit(unit)
		if not UnitExists(unit) then return end	
		local guid = UnitGUID(unit)
		if not guid then return end

		raid[guid] = unit
		
	--	print(raid[guid], guid, unit)
	end
	
	function SPTimers:GetRaidGUID(guid)		
		return raid[guid]
	end
	
	local auratypes = {
		['DEBUFF']	= 'HARMFUL',
		['BUFF']	= 'HELPFUL',
		['HARMFUL'] = 'HARMFUL',
		['HELPFUL'] = 'HELPFUL',
	}
	
	function SPTimers:GuidAuraInfo(guid, spell, auratype)
		if not raid[guid] then return end

		local spellname = type(spell) == "number" and GetSpellInfo(spell) or spell
		
		local name, _, _, count, debuffType, duration, endTime, unitCaster, _, _, spellID = UnitAura(raid[guid], spellname, nil, auratypes[auratype])
		
	--	print("GuidAuraInfo", guid, spell, auratype, name, auratypes[auratype])
		if name and ( spellname == name or spell == spellID ) then		
			return name, count, spellID, duration, endTime, unitCaster, debuffType
		end
		
		return nil
	end
	
	function SPTimers:UpdateRaid()
		wipe(raid)

		LeaveFromRaidOrGroup()
		
		if IsInRaid() then
		  for i = 1, GetNumGroupMembers() do
			CheckUnit(format("raid%d", i))
		  end
		end
		
		if IsInGroup() and not IsInRaid() then
		  for i = 1, GetNumSubgroupMembers() do
			CheckUnit(format("party%d", i))
		  end
		end
		
		CheckUnit("player")
	end
end

do
	local isInPetBattle = C_PetBattles.IsInBattle;
	function SPTimers:PET_BAR_UPDATE()
--		print("SPTimers:PET_BAR_UPDATE", isInPetBattle())		
		if ( options.hide_during_petbattle and isInPetBattle() ) then 
			parent:Hide() 
		else 
			parent:Show() 
		end
	end
end

local LSM_Update = CreateFrame("Frame")
LSM_Update:Hide()
LSM_Update:SetScript("OnUpdate", function(self, elapsed)
	self.elapsed = ( self.elapsed or 0 ) + elapsed
	
	if self.elapsed < 0.1 then return end
	
	SPTimers:Visibility()
	SPTimers.UpdateSettings()
	SPTimers.UpdateCastBarsStyle()
	
--	print("update visual2")
	
	self:Hide()
	self.elapsed = 0
end)
SPTimers.SharedMedia.RegisterCallback(LSM_Update, "LibSharedMedia_Registered", function(mtype, key)
--	print("update visual1")
	LSM_Update:Show();	
end)

function SPTimers:OnInitialize()

	self.myGUID = UnitGUID("player")

	local _,class = UnitClass("player")	
	self.myCLASS = class
	self.petGUID = UnitGUID("pet")
	self.myNAME = UnitName("player")
	
	self.myHaste = 1
	
	self:DefaultOptions()
	
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChange")
	
	self.options = self:OptionsTable()
	
	if self.SetupClassOptions then
		self:SetupClassOptions()
	end

	self:InitSupports()
	
    LibStub('LibDualSpec-1.0'):EnhanceDatabase(self.db, "SPTimers")
    LibStub('LibDualSpec-1.0'):EnhanceOptions(self.options.args.profile, self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SPTimers", self.options)
	
	options = self.db.profile
	
	minimap_icon:Register("SPTimers Minimap", SPTimersLDB, options)
	
	self:InitFrames()
	self:InitCooldownLine()
	self:CastBarInit()
	self:CoPToggle()
	
	self:RegisterEvent("UNIT_AURA")

	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")

	self:RegisterEvent("BN_CONNECTED", "CheckDebugging")
	self:RegisterEvent("BN_SELF_ONLINE", "CheckDebugging")
	self:RegisterEvent("BN_INFO_CHANGED", "CheckDebugging")
	
	self:RegisterEvent("PLAYER_LOGIN")
	
	--self:PlayerLoginDelay(function() SPTimers:UpdateEnchants() end)
	self:PlayerLoginDelay(function() SPTimers:UpdateTotems() end)
	self:PlayerLoginDelay(function() SPTimers:UpdateMinimap() end)
	
	self:RegisterEvent("GROUP_ROSTER_UPDATE", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND", "UpdateRaid")
	self:RegisterEvent("GROUP_JOINED", "UpdateRaid")
	self:RegisterEvent("RAID_INSTANCE_WELCOME", "UpdateRaid")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "UpdateRaid")
	
	self:RegisterEvent("PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_OPENING_START", "PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_OPENING_DONE", "PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_CLOSE", "PET_BAR_UPDATE")
	self:RegisterEvent("PET_BATTLE_OVER", "PET_BAR_UPDATE")

	
	
	self:RegisterEvent("UNIT_PET")
	
	self:ScanForChannelingSpell()
	self:RebuildBanCD()
	self:CoreBarsStatusUpdate()
	self:CheckDebugging()
	self:UpdateBars_CooldownPart()
	self:InitVersionCheck()
end

function SPTimers:OnProfileChange()
	
	print("T", "OnProfileChange")
	
	self.onUpdateHandler:SetScript("OnUpdate", nil)
	
	self.myGUID = UnitGUID("player")

	local _,class = UnitClass("player")	
	self.myCLASS = class
	self.petGUID = UnitGUID("pet")
	self.myNAME = UnitName("player")

	self:DefaultOptions()
	
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChange")
    self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChange")
	
	self.options = self:OptionsTable()
	
	if self.SetupClassOptions then
		self:SetupClassOptions()
	end

	self:InitSupports()
	
    LibStub('LibDualSpec-1.0'):EnhanceDatabase(self.db, "SPTimers")
    LibStub('LibDualSpec-1.0'):EnhanceOptions(self.options.args.profile, self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SPTimers", self.options)
	
	options = self.db.profile

	self:ProfileSwapBars()
	self:InitCooldownLine()
	self:CastBarInit()
	self:CoPToggle()
	
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("GROUP_ROSTER_UPDATE", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateRaid")
	self:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND", "UpdateRaid")
	self:RegisterEvent("GROUP_JOINED", "UpdateRaid")
	self:RegisterEvent("RAID_INSTANCE_WELCOME", "UpdateRaid")
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "UpdateRaid")
	self:RegisterEvent("UNIT_PET")

	self:RebuildBanCD()
	self:CheckDebugging()
	self:UpdateMinimap() 
	self:ScanForChannelingSpell()	
	self:CoreBarsStatusUpdate()
--	self:UpdateEnchants()
	self:UpdateTotems()
	self:UpdateBars_CooldownPart()
	
	self:OnAnchorStyleReset()
end

do
	local mover_frames = {}
	local function createbutton(parent, name)
		if not parent.buttons then parent.buttons = {} end
		
		local f = CreateFrame("Button", parent:GetName().."Button"..#parent.buttons+1, parent)
		f:SetFrameLevel(parent:GetFrameLevel() + 1)
		f.parent = parent
		f:SetText(name)
		f:SetWidth(20) --ширина
		f:SetHeight(20) --высота
		f:SetNormalFontObject("GameFontNormalSmall")
		f:SetHighlightFontObject("GameFontHighlightSmall")
		f:SetBackdrop({
				bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeSize = 1,
				insets = {top = 0, left = 0, bottom = 0, right = 0},
					})
		f:SetBackdropColor(0,0,0,1)
		f:SetBackdropBorderColor(.3,.3,.3,1)
		
		f:SetScript("OnEnter", function(self)
				self:SetBackdropBorderColor(1,1,1,1) --цвет краев
			end)
			f:SetScript("OnLeave", function(self)
				self:SetBackdropBorderColor(.3,.3,.3,1) --цвет краев
			end)
			
		local t = f:GetFontString()
		t:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
		t:SetJustifyH("CENTER")
		t:SetJustifyV("CENTER")
		f.text = t
		
		return f
	end
	
	local function createeditboxe(parent)
		if not parent.editboxes then parent.editboxes = {} end
		local textbox = CreateFrame("EditBox", parent:GetName().."EditBox"..#parent.editboxes+1, parent)
		textbox:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
		textbox:SetFrameLevel(parent:GetFrameLevel() + 1)
		textbox:SetAutoFocus(false)
		textbox:SetWidth(50)
		textbox:SetHeight(20)
		textbox:SetJustifyH("LEFT")
		textbox:SetJustifyV("CENTER")
		textbox:SetBackdrop({
				bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeFile = [=[Interface\ChatFrame\ChatFrameBackground]=],
				edgeSize = 1,
				insets = {top = 0, left = 0, bottom = 0, right = 0},
					})
		textbox:SetBackdropColor(0,0,0,1)
		textbox:SetBackdropBorderColor(1,1,1,0.5)
		
		textbox.ok = createbutton(textbox, "OK")
		textbox.ok.editbox = textbox
		textbox.ok.text:SetFont("Fonts\\ARIALN.TTF", 10, "OUTLINE")
		textbox.ok:SetSize(15,15)
		textbox.ok:SetPoint("RIGHT", textbox, "RIGHT", -2, 0)
		textbox.ok:Hide()
		
		textbox:SetScript("OnEscapePressed", function(self)
			self:ClearFocus()
		end)
		textbox:SetScript("OnEnterPressed", function(self)
			self.ChangePosition(self.ok)
		end)
		return textbox
	end
	
	local buttons_name = { "◄", "▲", "▼", "►" }
	local buttons_move = { { -1, 0 } , { 0, 1 }, { 0, -1} , { 1, 0} }
	
	function SPTimers:UpdateMoverPosition()
		for k,v in pairs(mover_frames) do
			k:UpdatePoint()
		end
	end
	
	local _unnm = 0
	local function CountUnnamesFrames()
		_unnm = _unnm + 1
		
		return _unnm
	end

	function SPTimers.AddMoverButtons(self, opts, tip, tomover, float)
		if not self.mover_add_button then			
			self.mover_add_button = CreateFrame("Frame", (self:GetName() or "SPTimersUnnamedFrame"..CountUnnamesFrames()).."MoverToolTip", self)
			self.mover_add_button.mover = self
			self.mover_add_button.opts = opts
			self.mover_add_button.tip = tip
			self.mover_add_button.tomover = tomover
			self.mover_add_button.float = float
			self.mover_add_button.buttons = {}
			self.mover_add_button.editboxes = {}
			self.mover_add_button:SetSize(120, 70)
			self.mover_add_button:SetClampedToScreen(true)
			self.mover_add_button:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground",})	
			self.mover_add_button:SetBackdropColor(0, 0, 0, 0.7)
			self.mover_add_button:Show()
			self.mover_add_button.UpdatePoint = function(self)
				
				self:ClearAllPoints()
				
				if self.tomover then
					self:SetPoint("TOP", self.mover, "TOP",0,-3)
					self:SetBackdropColor(0, 0, 0, 0)
				else
					if self.opts and not self.opts.add_up then
						self:SetPoint("BOTTOM", self.mover, "TOP",0, 3)
					else
						self:SetPoint("TOP", self.mover, "BOTTOM",0,-3)
					end
				end
				
				if options.show_more_buttons then 
					self:Show()
				else
					self:Hide()
				end
				
				for k,v in pairs(self.editboxes) do
					v:UpdateText()
				end
			end
			
			mover_frames[self.mover_add_button] = true
			
			for i=1,4 do				
				self.mover_add_button.buttons[i] = createbutton(self.mover_add_button, buttons_name[i])
				self.mover_add_button.buttons[i].i = i
				self.mover_add_button.buttons[i].owner = self.mover_add_button
				
				if i == 1 then
					self.mover_add_button.buttons[i]:SetPoint("TOPRIGHT", self.mover_add_button, "TOP", 0, -3)
				elseif i == 2 then
					self.mover_add_button.buttons[i]:SetPoint("TOPRIGHT", self.mover_add_button, "TOP", -21, -3)
				elseif i == 3 then
					self.mover_add_button.buttons[i]:SetPoint("TOPLEFT", self.mover_add_button, "TOP", 0, -3)
				elseif i == 4 then
					self.mover_add_button.buttons[i]:SetPoint("TOPLEFT", self.mover_add_button, "TOP", 21, -3)
				end
				
				self.mover_add_button.buttons[i]:SetScript("OnClick", function(self)
					
					if self.owner.opts then
						self.owner.opts.point[1] = (tonumber(self.owner.opts.point[1]) or 0) + buttons_move[self.i][1]
						self.owner.opts.point[2] = (tonumber(self.owner.opts.point[2]) or 0) + buttons_move[self.i][2]
						
						self.owner.mover:ClearAllPoints()
						self.owner.mover:SetPoint("CENTER", parent, "CENTER", self.owner.opts.point[1], self.owner.opts.point[2] )
					elseif self.owner.tip and self.owner.tip == "line" then
					
						SPTimers.db.profile.cooldownline.x = (tonumber(SPTimers.db.profile.cooldownline.x) or 0) + buttons_move[self.i][1]
						SPTimers.db.profile.cooldownline.y = (tonumber(SPTimers.db.profile.cooldownline.y) or 0) + buttons_move[self.i][2]
						
						self.owner.mover:ClearAllPoints()
						self.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.x, SPTimers.db.profile.cooldownline.y)
					elseif self.owner.tip and self.owner.tip == "splash" then
						SPTimers.db.profile.cooldownline.slash_x = (tonumber(SPTimers.db.profile.cooldownline.slash_x) or 0) + buttons_move[self.i][1]
						SPTimers.db.profile.cooldownline.slash_y = (tonumber(SPTimers.db.profile.cooldownline.slash_y) or 0) + buttons_move[self.i][2]
						
						self.owner.mover:ClearAllPoints()
						self.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.slash_x, SPTimers.db.profile.cooldownline.slash_y)
					end
					for k,v in pairs(self.owner.editboxes) do
						v:UpdateText()					
					end
				end)
			end
			
			if float then
				self.mover_add_button.buttons[5] = createbutton(self.mover_add_button, "=====")
				self.mover_add_button.buttons[5]:SetPoint("BOTTOM", self.mover_add_button, "BOTTOM", 0, 3)
				self.mover_add_button.buttons[5]:SetSize(50, 10)
				self.mover_add_button.buttons[5].owner = self.mover_add_button
				self.mover_add_button.buttons[5]:SetScript("OnClick", function(self)
					local a1,a2,a3,a4,a5 = self.owner:GetPoint()
					self.owner:ClearAllPoints()
					self.owner:SetPoint(a3,a2,a1,0, -a5)
				end)
			end
			
			for i=1,2 do				
				self.mover_add_button.editboxes[i] = createeditboxe(self.mover_add_button)
				self.mover_add_button.editboxes[i].i = i
				self.mover_add_button.editboxes[i].owner = self.mover_add_button
				
				if i == 1 then
					self.mover_add_button.editboxes[i]:SetPoint("TOPRIGHT", self.mover_add_button, "TOP", -1, -30)
				else
					self.mover_add_button.editboxes[i]:SetPoint("TOPLEFT", self.mover_add_button, "TOP", 1, -30)
				end
				
				self.mover_add_button.editboxes[i]:SetScript("OnTextChanged", function(self, user)
					if user then
						self.ok:Show()
						
						self.ok:SetScript("OnClick", self.ChangePosition)
					end
				end)
				
				self.mover_add_button.editboxes[i].ChangePosition = function(self)
					local num = tonumber(self.editbox:GetText())				
					if num then
						if self.editbox.owner.opts then
							self.editbox.owner.opts.point[self.editbox.i] = num
								
							self.editbox.owner.mover:ClearAllPoints()
							self.editbox.owner.mover:SetPoint("CENTER", parent, "CENTER", self.editbox.owner.opts.point[1], self.editbox.owner.opts.point[2])
						elseif self.editbox.owner.tip and self.editbox.owner.tip == "line" then
							
							if self.editbox.i == 1 then
								SPTimers.db.profile.cooldownline.x = num
							else
								SPTimers.db.profile.cooldownline.y = num
							end
							
							self.editbox.owner.mover:ClearAllPoints()
							self.editbox.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.x, SPTimers.db.profile.cooldownline.y)
						elseif self.editbox.owner.tip and self.editbox.owner.tip == "splash" then
							if self.editbox.i == 1 then
								SPTimers.db.profile.cooldownline.slash_x = num
							else
								SPTimers.db.profile.cooldownline.slash_y = num
							end
							self.editbox.owner.mover:ClearAllPoints()
							self.editbox.owner.mover:SetPoint("CENTER", parent, "CENTER", SPTimers.db.profile.cooldownline.slash_x, SPTimers.db.profile.cooldownline.slash_y)
						end
					else
						self.editbox:UpdateText()
					end
					self:SetScript("OnClick", nil)
					self:Hide()
					
					self.editbox:ClearFocus()
				end
				self.mover_add_button.editboxes[i]:SetScript("OnShow", function(self) self:UpdateText() end)
				
				self.mover_add_button.editboxes[i].UpdateText = function(self)
					if self.owner.opts then
						self:SetText(tonumber(self.owner.opts.point[self.i]) or 0)
					elseif self.owner.tip and self.owner.tip == "line" then
						if self.i == 1 then
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.x) or 0)
						else
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.y) or 0)
						end
					elseif self.owner.tip and self.owner.tip == "splash" then
						if self.i == 1 then
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.slash_x) or 0)
						else
							self:SetText(tonumber(SPTimers.db.profile.cooldownline.slash_y) or 0)
						end
					end
				end
				
				self.mover_add_button.editboxes[i]:UpdateText()
			end
		end
		self.mover_add_button.opts = opts
			
		self.mover_add_button.x = x
		self.mover_add_button.y = y
		self.mover_add_button:UpdatePoint()
	end
end


do
	
	local hooksecurefunc, select, UnitBuff, UnitDebuff, UnitAura, UnitGUID, GetGlyphSocketInfo, tonumber, strfind, strsub, strmatch =
      hooksecurefunc, select, UnitBuff, UnitDebuff, UnitAura, UnitGUID, GetGlyphSocketInfo, tonumber, strfind, strsub, strmatch

	local types = {
		spell      = "|cFFCA3C3CSpell ID:|r",
		item       = "|cFFCA3C3CItem ID:|r",
		talent     = "|cFFCA3C3CTalent ID:|r",
	}

	local function addLine(tooltip, id, type)
		local found = false

		-- Check if we already added to this tooltip. Happens on the talent frame
		for i = 1,15 do
			local frame = _G[tooltip:GetName() .. "TextLeft" .. i]
			local text
			if frame then text = frame:GetText() end
			if text and text == type then found = true break end
		end

		if not found then
			tooltip:AddDoubleLine(type, "|cffffffff" .. id)
			tooltip:Show()
		end
	end

	-- All types, primarily for linked tooltips
	local function onSetHyperlink(self, link)
		if not options.show_item_spellid then return end
		local type, id = string.match(link,"^(%a+):(%d+)")
		if not type or not id then return end
		if type == "spell" then
			addLine(self, id, types.spell)
		elseif type == "talent" then
			addLine(self, id, types.talent)
		elseif type == "item" then
			addLine(self, id, types.item)
		end
	end

	hooksecurefunc(ItemRefTooltip, "SetHyperlink", onSetHyperlink)
	hooksecurefunc(GameTooltip, "SetHyperlink", onSetHyperlink)

	-- Spells
	hooksecurefunc(GameTooltip, "SetUnitBuff", function(self, ...)
		if not options.show_item_spellid then return end
		local id = select(11, UnitBuff(...))
		if id then addLine(self, id, types.spell) end
	end)

	hooksecurefunc(GameTooltip, "SetUnitDebuff", function(self,...)
		if not options.show_item_spellid then return end
		local id = select(11, UnitDebuff(...))
		if id then addLine(self, id, types.spell) end
	end)

	hooksecurefunc(GameTooltip, "SetUnitAura", function(self,...)
		if not options.show_item_spellid then return end
		local id = select(11, UnitAura(...))
		if id then addLine(self, id, types.spell) end
	end)

	hooksecurefunc("SetItemRef", function(link, ...)
		if not options.show_item_spellid then return end
		local id = tonumber(link:match("spell:(%d+)"))
		if id then addLine(ItemRefTooltip, id, types.spell) end
	end)

	GameTooltip:HookScript("OnTooltipSetSpell", function(self)
		if not options.show_item_spellid then return end
		local id = select(3, self:GetSpell())
		if id then addLine(self, id, types.spell) end
	end)


	-- Items
	local function attachItemTooltip(self)
		if not options.show_item_spellid then return end
		local link = select(2, self:GetItem())
		if link then
			local id = select(3, strfind(link, "^|%x+|Hitem:(%-?%d+):(%d+):(%d+).*"))
			if id then addLine(self, id, types.item) end
		end
	end

	GameTooltip:HookScript("OnTooltipSetItem", attachItemTooltip)
	ItemRefTooltip:HookScript("OnTooltipSetItem", attachItemTooltip)
	ItemRefShoppingTooltip1:HookScript("OnTooltipSetItem", attachItemTooltip)
	ItemRefShoppingTooltip2:HookScript("OnTooltipSetItem", attachItemTooltip)
	ShoppingTooltip1:HookScript("OnTooltipSetItem", attachItemTooltip)
	ShoppingTooltip2:HookScript("OnTooltipSetItem", attachItemTooltip)
	
end
